## ordered-map 0.8.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
include(GNUInstallDirs)


project(tsl-ordered-map VERSION 0.8.1)

add_library(ordered_map INTERFACE)
# Use tsl::ordered_map as target, more consistent with other libraries conventions (Boost, Qt, ...)
add_library(tsl::ordered_map ALIAS ordered_map)

target_include_directories(ordered_map INTERFACE
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

list(APPEND headers "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/ordered_hash.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/ordered_map.h"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl/ordered_set.h")
target_sources(ordered_map INTERFACE "$<BUILD_INTERFACE:${headers}>")

if(MSVC)
    target_sources(ordered_map INTERFACE
                   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/tsl-ordered-map.natvis>"
                   "$<INSTALL_INTERFACE:${CMAKE_INSTALL_DATAROOTDIR}/tsl-ordered-map.natvis>")
endif()




# Installation (only compatible with CMake version >= 3.3)
if(${CMAKE_VERSION} VERSION_GREATER "3.2")
    include(CMakePackageConfigHelpers)

    ## Install include directory and potential natvis file
    install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/tsl"
            DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

    if(MSVC)
        install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/tsl-ordered-map.natvis"
                DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}")
    endif()



    ## Create and install tsl-ordered-mapConfig.cmake
    configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/tsl-ordered-mapConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/tsl-ordered-mapConfig.cmake"
                                  INSTALL_DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-ordered-map")

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tsl-ordered-mapConfig.cmake"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-ordered-map")



    ## Create and install tsl-ordered-mapTargets.cmake
    install(TARGETS ordered_map
            EXPORT tsl-ordered-mapTargets)

    install(EXPORT tsl-ordered-mapTargets
            NAMESPACE tsl::
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-ordered-map")



    ## Create and install tsl-ordered-mapConfigVersion.cmake
    # tsl-ordered-map is header-only and does not depend on the architecture.
    # Remove CMAKE_SIZEOF_VOID_P from tsl-ordered-mapConfigVersion.cmake so that a
    # tsl-ordered-mapConfig.cmake generated for a 64 bit target can be used for 32 bit
    # targets and vice versa.
    set(CMAKE_SIZEOF_VOID_P_BACKUP ${CMAKE_SIZEOF_VOID_P})
    unset(CMAKE_SIZEOF_VOID_P)
    write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/tsl-ordered-mapConfigVersion.cmake"
                                     COMPATIBILITY SameMajorVersion)
    set(CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P_BACKUP})

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tsl-ordered-mapConfigVersion.cmake"
            DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/cmake/tsl-ordered-map")
endif()

=== debian/changelog ===
ordered-map (0.8.1-2) unstable; urgency=medium

  * Add git-buildpackage configuration

 -- Hilko Bengen <bengen@debian.org>  Sun, 31 May 2020 22:10:50 +0200

ordered-map (0.8.1-1) experimental; urgency=medium

  * Initial release (Closes: #951373)

 -- Hilko Bengen <bengen@debian.org>  Sat, 15 Feb 2020 01:05:12 +0100

## ordered-map 1.0.0

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)

project(tsl_ordered_map_tests)

add_executable(tsl_ordered_map_tests "main.cpp" 
                                     "custom_allocator_tests.cpp" 
                                     "ordered_map_tests.cpp" 
                                     "ordered_set_tests.cpp")

target_compile_features(tsl_ordered_map_tests PRIVATE cxx_std_11)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    target_compile_options(tsl_ordered_map_tests PRIVATE -Werror -Wall -Wextra -Wold-style-cast -DTSL_DEBUG -UNDEBUG)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    target_compile_options(tsl_ordered_map_tests PRIVATE /bigobj /WX /W3 /DTSL_DEBUG /UNDEBUG)
endif()

# Boost::unit_test_framework
find_package(Boost 1.54.0 REQUIRED COMPONENTS unit_test_framework)
target_link_libraries(tsl_ordered_map_tests PRIVATE Boost::unit_test_framework)   

# tsl::ordered_map
add_subdirectory(../ ${CMAKE_CURRENT_BINARY_DIR}/tsl)
target_link_libraries(tsl_ordered_map_tests PRIVATE tsl::ordered_map)

=== debian/changelog ===
ordered-map (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0
  * Update upstream author's name in debian/copyiright

 -- Hilko Bengen <bengen@debian.org>  Sun, 13 Sep 2020 12:33:45 +0200

=== debian/control ===
Source: ordered-map
Section: libdevel
Priority: optional
Maintainer: Hilko Bengen <bengen@debian.org>
Build-Depends: debhelper (>= 12~),
 cmake,
 libboost-test-dev,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/bro-team/ordered-map
Vcs-Git: https://salsa.debian.org/bro-team/ordered-map.git
Homepage: https://github.com/Tessil/ordered-map/

Package: libtsl-ordered-map-dev
Architecture: any
Depends: ${misc:Depends}
Description: C++ insertion-order-preserving hash map and hash set
 The ordered-map library provides a hash map and a hash set which
 preserve the order of insertion in a way similar to Python's
 OrderedDict. When iterating over the map, the values will be returned
 in the same order as they were inserted.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_configure --sourcedirectory=tests --builddirectory=build-tests
endif

override_dh_auto_build:
	dh_auto_build
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --sourcedirectory=tests --builddirectory=build-tests
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd build-tests && ./tsl_ordered_map_tests
endif

=== debian/watch ===
version=4

https://github.com/Tessil/ordered-map/releases .*/archive/v?@ANY_VERSION@@ARCHIVE_EXT@
